/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/lib_tva.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");

var com_id;
var mode_ligne;
var client_id;
var affaire_id;
var mode;
var etat_commande;
var mode_tarif;
var initLigne = false;
var currentRank = 0;
var type_remise = 'P';
var editionTTC = false;
var currentTotalHT = 0;
var currentMontantTTC = 0;
var zoneUE=false;
var charger = true;
var assujettiTVA = (ParamValeur("Assujetti_TVA")=="1");
var numTVA = ParamValeur("Num_TVA_Intra");
var tva_port;

var nf = new NumberFormat("0.00", false);


function init() {
  try {
  	
  	var qParam = new QueryHttp("Config/gestion_commerciale/preferences/getParam.tmpl");
		var result = qParam.execute();
		
		var act_code_stats = (parseInt(result.responseXML.documentElement.getAttribute('Act_Code_Stats'))==1);
		var produit_frais = (parseInt(result.responseXML.documentElement.getAttribute('Produit_Frais'))==1);
		if (!act_code_stats) {
			document.getElementById('ColCode_Stats').collapsed = true;
	  	document.getElementById('Act_Code_Stats').collapsed = true;
		} else {
			document.getElementById('labelRef').setAttribute('style', 'margin-left:0px');
			document.getElementById('Reference').setAttribute('style', 'margin-left:0px');
		}
		
		if (!produit_frais) {
			document.getElementById('ColNum_Lot').collapsed = true;
			document.getElementById('ColNb_Pieces').collapsed = true;
			document.getElementById('ColUnite').collapsed = true;
			document.getElementById('ColDate_Peremption').collapsed = true;
			document.getElementById('Produit_Frais_1').collapsed = true;
			document.getElementById('Produit_Frais_2').collapsed = true;
			document.getElementById('Produit_Frais_3').collapsed = true;
			document.getElementById('Produit_Frais_4').collapsed = true;
		}

		setModeTarif();
		
		// liste des units de l'article
		var aUnite = new Arbre("fact", "unites_vente.tmpl", "Unite");
		aUnite.initTree(initUnite);
		
		var qTypeVente = new QueryHttp("GetPays.tmpl");
	  qTypeVente.setParam("Code_Pays", ParamValeur("Code_Pays_Liv"));
	  var result = qTypeVente.execute();
	  zoneUE = (result.responseXML.documentElement.getAttribute("zone_ue")=="1");

		init_2();

	} catch (e) {
  	recup_erreur(e);
	}
}

function initUnite() {
	try {

    document.getElementById('Unite').selectedIndex = 0;

	} catch (e) {
    recup_erreur(e);
  }
}


function listeTVA() {
  try {
  	tva_port = getTvaNormal(ParamValeur("Code_Pays_Liv"),assujettiTVA,document.getElementById("Regime_TVA").value);
    calculTotaux();
    var aCode = new Arbre("fact", "taux_tva.tmpl", "Code_TVA");
    aCode.setParam("Code_Pays", ParamValeur("Code_Pays_Liv"));
    aCode.setParam("Regime_TVA", document.getElementById("Regime_TVA").value);
    aCode.setParam("Assujetti_TVA", assujettiTVA?"1":"0");
    aCode.initTree(selectTVA);
  
  } catch (e) {
    recup_erreur(e);
  }
}

 function selectTVA() {
  try {
    document.getElementById('Code_TVA').value = getCodeTvaNormal(ParamValeur("Code_Pays_Liv"),assujettiTVA,document.getElementById("Regime_TVA").value);
  } catch (e) {
    recup_erreur(e);
  }
}


function init_2() {
  try {

		affaire_id = ParamValeur("Affaire_Id");

		document.getElementById("Raison_Sociale").value = ParamValeur("Raison_Sociale");
		document.getElementById("Adresse_Fact").value = ParamValeur("Adresse_Fact");
		document.getElementById("CP_Fact").value = ParamValeur("CP_Fact");
		document.getElementById("Ville_Fact").value = ParamValeur("Ville_Fact");
		client_id = ParamValeur("Client_Id");
		document.getElementById("Client").setAttribute("label","Client N "+ client_id);
		document.getElementById("Affaire").setAttribute("label","Affaire N "+ ParamValeur("Num_Affaire"));
		document.getElementById("Nom_Affaire").value = ParamValeur("Nom_Affaire");
		document.getElementById("Responsable").value = ParamValeur("Responsable");

		window.parent.addEventListener("close",demandeEnregistrement,false);

		mode = ParamValeur("Mode");

		if (mode=="C") {
			nouvelleCommande();
		}
		else {

			// chargement

			com_id = ParamValeur("Com_Id");

			initLigne = true;

			init_tree();

			var corps = cookie() +"&Page=Facturation/Affaires/loadArticleComTemp.tmpl&ContentType=xml&Com_Id="+ com_id;
			requeteHTTP(corps);
		}

		var corps = cookie() +"&Page=Facturation/Commun/getIndicationsCommandeClient.tmpl&ContentType=xml&Client_Id="+ client_id;
		var p = requeteHTTP(corps);

		document.getElementById('Indications').value = p.responseXML.documentElement.getAttribute("Indications");

	} catch (e) {
  	recup_erreur(e);
	}
}


function setModeTarif() {
	try {

    var corps = cookie() + "&Page=Config/gestion_commerciale/preferences/getParam.tmpl&ContentType=xml";
    var p = requeteHTTP(corps);

		mode_tarif = p.responseXML.documentElement.getAttribute('Mode_Tarif');

		if (mode_tarif=='Q') {
			document.getElementById('row_tarif').collapsed = true;
		}

	} catch (e) {
		recup_erreur(e);
	}
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur(e);
  }
}


function switchRemise() {
	try {

		if (type_remise=='P') {
			document.getElementById('bRemise').setAttribute("label", "\u20AC");
			type_remise = 'M';
		}
		else {
			document.getElementById('bRemise').setAttribute("label", "%");
			type_remise = 'P';
		}
		calculTotaux();
		setModifie(true);

	} catch (e) {
    recup_erreur(e);
  }
}



function disableAll() {
	try {

		mode = "V";

		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('bChoisirMentions').disabled = true;
		document.getElementById('Remise').disabled = true;
		document.getElementById('Escompte').disabled = true;
		document.getElementById('Acompte').disabled = true;
		document.getElementById('Ref_Com').disabled = true;
		document.getElementById('Frais_Port').disabled = true;
		document.getElementById('Delai').disabled = true;
		document.getElementById('Edition_TTC').disabled = true;

		document.getElementById('bCommentaire').disabled = true;
		document.getElementById('bArticle').disabled = true;
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bValiderCommande').disabled = true;
		document.getElementById('bRemise').disabled = true;

		formatLigne("");

	} catch (e) {
    recup_erreur(e);
  }
}


function ajouterLigne(type_ligne) {
  try {

		document.getElementById('bSupprimer').disabled = true;
		mode_ligne = "C";

		document.getElementById("Type_Ligne").value = type_ligne;

		formatLigne(type_ligne);

		switch(type_ligne) {
			case "S":

				var reference = document.getElementById("Reference").value;

				if (!isEmpty(reference)) {

					if (mode_tarif=='Q') {

						var url = "chrome://opensi/content/facturation/user/commun/popup-choixTarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    				window.openDialog(url,'','chrome,modal,centerscreen', reporterTarifId);

						var tarif_id = document.getElementById('Tarif_Id').value;

						if (!isEmpty(tarif_id)) {

							var corps = cookie() +"&Page=Facturation/Affaires/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
							corps += "&Tarif_Id="+ tarif_id;
							corps += "&Type_Prix="+ (editionTTC?"TTC":"HT");

							var p = requeteHTTP(corps);

							var contenu = p.responseXML.documentElement;

							document.getElementById("Code_Stats").value = contenu.getAttribute("Code_Stats");
							document.getElementById("Designation").value = contenu.getAttribute("Designation");
							document.getElementById("Num_Lot").value = "";
							document.getElementById("Nb_Pieces").value = "";
							document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
							document.getElementById('Unite').value = contenu.getAttribute("Unite");
							document.getElementById("Date_Peremption").value = "";
							document.getElementById("PU").value = contenu.getAttribute("Prix");
							document.getElementById('Ristourne').value = "0.00";
							document.getElementById("Code_TVA").value = getCodeTvaCorrespondant(contenu.getAttribute("Code_TVA"),ParamValeur('Code_Pays_Liv'),assujettiTVA,document.getElementById("Regime_TVA").value);
							document.getElementById("Tarif_Id").value = "";
							document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
						}
						else {
							ajouterLigne("I");
						}
					}
					else {
						var corps = cookie() + "&Page=Facturation/Affaires/getArticleTarif.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
						corps += "&Code_Tarif="+ document.getElementById('Code_Tarif').value +"&Client_Id="+ urlEncode(client_id);
						corps += "&Type_Prix="+ (editionTTC?"TTC":"HT");
						var p = requeteHTTP(corps);

						var contenu = p.responseXML.documentElement;
						
						document.getElementById("Code_Stats").value = contenu.getAttribute("Code_Stats");
						document.getElementById("Designation").value = contenu.getAttribute("Designation");
						document.getElementById("Num_Lot").value = "";
						document.getElementById("Nb_Pieces").value = "";
						document.getElementById('Quantite').value = 1;
						document.getElementById('Unite').value = contenu.getAttribute("Unite");
						document.getElementById("Date_Peremption").value = "";
						document.getElementById("PU").value = contenu.getAttribute("Prix");
						document.getElementById('Ristourne').value = "0.00";
						document.getElementById("Code_TVA").value = getCodeTvaCorrespondant(contenu.getAttribute("Code_TVA"),ParamValeur('Code_Pays_Liv'),assujettiTVA,document.getElementById("Regime_TVA").value);
						document.getElementById("Libelle").value = "";
					}
				}
				else {
					ajouterLigne("I");
				}

				break;

			case "I":

				document.getElementById('Code_Stats').value = "";
				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById("Num_Lot").value = "";
				document.getElementById("Nb_Pieces").value = "";
				document.getElementById('Quantite').value = 1;
				document.getElementById('Unite').value = "U";
				document.getElementById("Date_Peremption").value = "";
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "0.00";
				document.getElementById('Code_TVA').value = getCodeTvaNormal(ParamValeur('Code_Pays_Liv'),assujettiTVA,document.getElementById("Regime_TVA").value);
				document.getElementById('Libelle').value = "";
				break;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function formatLigne(type_ligne) {
  try {

		switch(type_ligne) {
			case "S":
				document.getElementById('Code_Stats').disabled = false;
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Num_Lot').disabled = false;
				document.getElementById('Nb_Pieces').disabled = false;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('Unite').disabled = false;
				document.getElementById('Date_Peremption').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = false;
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;

			case "I":
				document.getElementById('Code_Stats').disabled = false;
				document.getElementById('Reference').disabled = false;
				document.getElementById('Designation').disabled = false;
				document.getElementById('Num_Lot').disabled = false;
				document.getElementById('Nb_Pieces').disabled = false;
				document.getElementById('Quantite').disabled = false;
				document.getElementById('Unite').disabled = false;
				document.getElementById('Date_Peremption').disabled = false;
				document.getElementById('PU').disabled = false;
				document.getElementById('Ristourne').disabled = false;
				document.getElementById('Code_TVA').disabled = false;
				document.getElementById('bValider').disabled = false;
				document.getElementById('bAnnuler').disabled = false;
				break;

			default:
				document.getElementById('Code_Stats').value = "";
				document.getElementById('Reference').value = "";
				document.getElementById('Designation').value = "";
				document.getElementById('Num_Lot').value = "";
				document.getElementById('Nb_Pieces').value = "";
				document.getElementById('Quantite').value = "";
				document.getElementById('Unite').value = "U";
				document.getElementById('Date_Peremption').value = "";
				document.getElementById('PU').value = "";
				document.getElementById('Ristourne').value = "";
				document.getElementById('Code_TVA').value = getCodeTvaNormal(ParamValeur("Code_Pays_Liv"),assujettiTVA,document.getElementById("Regime_TVA").value);
				document.getElementById('Libelle').value = "";
				document.getElementById('Code_Stats').disabled = true;
				document.getElementById('Reference').disabled = true;
				document.getElementById('Designation').disabled = true;
				document.getElementById('Num_Lot').disabled = true;
				document.getElementById('Nb_Pieces').disabled = true;
				document.getElementById('Quantite').disabled = true;
				document.getElementById('Unite').disabled = true;
				document.getElementById('Date_Peremption').disabled = true;
				document.getElementById('PU').disabled = true;
				document.getElementById('Ristourne').disabled = true;
				document.getElementById('Code_TVA').disabled = true;
				document.getElementById('bSupprimer').disabled = true;
				document.getElementById('bValider').disabled = true;
				document.getElementById('bAnnuler').disabled = true;
				break;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function pressOnWindow(ev) {
	try {

		if (ev.altKey) {
			switch(ev.charCode) {
      	case 97: // 'a'
        	rechercherStock();
        	break;
				case 116: // 't'
					modifierTarif();
					break;
    	}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function pressOnQuantite(ev) {
	try {
		
		if (ev.keyCode==13) {
			validerLigne();
		}
		
	} catch (e) {
    recup_erreur(e);
  }
}


function pressOnReference(ev) {
	try {

		if (ev.keyCode==13) {
			rechercherReference();
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function rechercherStock() {
	try {

		var url = "chrome://opensi/content/facturation/user/stocks/rech_stocks.xul?"+ cookie();
		if (mode_tarif != "Q") {
			url += "&Code_Tarif=" + document.getElementById('Code_Tarif').value;
		}
    window.openDialog(url,'','chrome,modal,centerscreen',retourRechercherStock);

	} catch (e) {
    recup_erreur(e);
  }
}


function retourRechercherStock(reference) {
	try {
	
		document.getElementById('Reference').value = reference;
		ajouterLigne("S");
	
	} catch (e) {
    recup_erreur(e);
  }
}


function rechercherReference() {
	try {

		var qExArt = new QueryHttp("Facturation/Recherches/rechReference.tmpl");
		qExArt.setFullParamById('Reference');
		var result = qExArt.execute();
		
		var articleId = result.responseXML.documentElement.getAttribute("Article_Id");
		
		if (!isEmpty(articleId)) {
			document.getElementById('Reference').value = articleId;
			ajouterLigne("S");
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function modifierTarif() {
	try {

		if (mode_ligne = "M" && document.getElementById('Type_Ligne').value=='S') {

			if (mode_tarif=='Q') {

				var reference = document.getElementById('Reference').value;

				var url = "chrome://opensi/content/facturation/user/commun/popup-choixTarif.xul?"+ cookie() +"&Article_Id="+ urlEncode(reference);
    		window.openDialog(url,'','chrome,modal,centerscreen', reporterTarifId);

				var tarif_id = document.getElementById('Tarif_Id').value;

				if (!isEmpty(tarif_id)) {

					var corps = cookie() + "&Page=Facturation/Affaires/getArticleQte.tmpl&ContentType=xml&Article_Id="+ urlEncode(reference);
					corps += "&Tarif_Id="+ tarif_id;
					corps += "&Type_Prix="+ (editionTTC?"TTC":"HT");

					var p = requeteHTTP(corps);

					var contenu = p.responseXML.documentElement;

					document.getElementById('Quantite').value = contenu.getAttribute("Quantite");
					document.getElementById('Unite').value = contenu.getAttribute("Unite");
					document.getElementById("PU").value = contenu.getAttribute("Prix");
					document.getElementById("Tarif_Id").value = "";
					document.getElementById("Libelle").value = contenu.getAttribute("Libelle");
				}
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function reporterTarifId(tarif_id) {
	try {
		document.getElementById('Tarif_Id').value = tarif_id;
	} catch (e) {
		recup_erreur(e);
	}
}


function ouvrirLigne() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {

			if (getCellText(tree,tree.currentIndex,'ColType_Ligne')=="C") {
				ajouterLigne("I");
			}
			else {
				mode_ligne = "M";
				document.getElementById('bSupprimer').disabled = false;

				document.getElementById("Code_Stats").value = getCellText(tree,tree.currentIndex,'ColCode_Stats');
				document.getElementById("Reference").value = getCellText(tree,tree.currentIndex,'ColReference');
				document.getElementById("Designation").value = getCellText(tree,tree.currentIndex,'ColDesignation');
				document.getElementById("Num_Lot").value = getCellText(tree,tree.currentIndex,'ColNum_Lot');
				document.getElementById("Nb_Pieces").value = getCellText(tree,tree.currentIndex,'ColNb_Pieces');
				document.getElementById("Quantite").value = getCellText(tree,tree.currentIndex,'ColQuantite');
				document.getElementById("Unite").value = getCellText(tree,tree.currentIndex,'ColUnite');
				document.getElementById("Date_Peremption").value = getCellText(tree,tree.currentIndex,'ColDate_Peremption');
				document.getElementById("PU").value = getCellText(tree,tree.currentIndex,'ColPU');
				document.getElementById("Code_TVA").value = getCellText(tree,tree.currentIndex,'ColCode_TVA');
				document.getElementById("Ristourne").value = getCellText(tree,tree.currentIndex,'ColRistourne');
				document.getElementById("Type_Ligne").value = getCellText(tree,tree.currentIndex,'ColType_Ligne');
				document.getElementById("Rank").value = getCellText(tree,tree.currentIndex,'ColRank');
				document.getElementById("Libelle").value = getCellText(tree,tree.currentIndex,'ColLibelle');

				formatLigne(document.getElementById("Type_Ligne").value);
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}

function ouvrirCommentaire() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1 && mode=="M") {

			if (getCellText(tree,tree.currentIndex,'ColType_Ligne')=="C") {
				editerCommentaire();
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function validerLigne() {
  try {

		var ok;

		if (mode=="C") {
			ok = enregistrerCommande();
		}
		else {
			ok = true;
		}

		if (ok) {

			if (mode_ligne=="C") {
				var corps = cookie() +"&Page=Facturation/Affaires/ajouterArticleCom.tmpl&ContentType=xml";
			}
			else {
				var corps = cookie() +"&Page=Facturation/Affaires/modifierArticleCom.tmpl&ContentType=xml";
			}

			var type_ligne = document.getElementById("Type_Ligne").value;
			var code_stats = document.getElementById("Code_Stats").value;
			var reference = document.getElementById("Reference").value;
			var designation = document.getElementById("Designation").value;
			var num_lot = document.getElementById("Num_Lot").value;
			var nb_pieces = document.getElementById("Nb_Pieces").value;
			var quantite = document.getElementById("Quantite").value;
			var unite = document.getElementById("Unite").value;
			var date_peremption = document.getElementById("Date_Peremption").value;
			var pu = document.getElementById("PU").value;
			var ristourne = document.getElementById("Ristourne").value;
			var code_tva = document.getElementById("Code_TVA").value;
			var rank = document.getElementById("Rank").value;
			var libelle = document.getElementById('Libelle').value;

			corps += "&Reference="+ urlEncode(reference) +"&Designation="+ urlEncode(designation) + "&Num_Lot=" + urlEncode(num_lot) + "&Nb_Pieces=" + nb_pieces +"&Quantite="+ quantite +"&Unite="+ urlEncode(unite) +"&Type_Ligne="+ type_ligne;
			corps += "&Prix="+ pu +"&Ristourne="+ ristourne +"&Code_TVA="+ code_tva +"&Com_Id="+ com_id +"&Rank="+ rank +"&Libelle="+ urlEncode(libelle);
			corps += "&Code_Stats=" + code_stats;

			if (isEmpty(designation)) { showWarning("Dsignation de l'article manquante !"); }
			else if (!checkQte(quantite)) { showWarning("Quantit incorrecte !");	}
			else if (!isEmpty(nb_pieces) && !isPositiveInteger(nb_pieces)) { showWarning("Nombre de pices incorrect !");	}
			else if (!isEmpty(date_peremption) && !isDate(date_peremption)) { showWarning("Date de premption incorrecte !");	}
			else if (isEmpty(pu) || !isPositiveOrNull(pu) || !checkDecimal(pu,4)) { showWarning("Prix unitaire incorrect !");	}
			else if (isEmpty(ristourne) || !isTaux(ristourne)) { showWarning("Taux de ristourne incorrect !");	}
			else {
				
				corps += "&Date_Peremption=" + (!isEmpty(date_peremption)?prepareDateJava(date_peremption):"");
				var p = requeteHTTP(corps);

  			currentRank = p.responseXML.documentElement.getAttribute('Rank');

				ajouterLigne("I");
				delete_tree();
				init_tree_temp();
				setModifie(true);
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function annulerLigne() {
  try {

		ajouterLigne("I");

	} catch (e) {
  	recup_erreur(e);
	}
}


function supprimerLigne() {
  try {

		var rank = document.getElementById("Rank").value;

		var corps = cookie() +"&Page=Facturation/Affaires/supprimerArticleCom.tmpl&ContentType=xml&Com_Id="+ com_id +"&Rank="+ rank;
		var p = requeteHTTP(corps);

		currentRank = rank;

		ajouterLigne("I");
		delete_tree();
		init_tree_temp();
		setModifie(true);

	} catch (e) {
  	recup_erreur(e);
	}
}


function validerCommande() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("La commande ne contient aucune ligne !");
		}
		else {
			if (window.confirm("Etes-vous sr de vouloir valider la commande ?")) {
				
				var qValider = new QueryHttp("Facturation/Affaires/validerCommande.tmpl");
				qValider.setParam('Com_Id', com_id);
				qValider.setParam('Affaire_Id', affaire_id);
				qValider.setParam('Client_Id', client_id);
				var result = qValider.execute();				

				if (result.responseXML.documentElement.getAttribute('code_erreur')=="1") {
					showWarning("Impossible de valider la commande, ce client est bloqu");	
				}
				else {
					showMessage("La commande a t valide !");
					retour_affaire();
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function enregistrerCommande() {
  try {

		var ok = false;

		var remise = document.getElementById('Remise').value;
		var taux_remise = 0;
		var montant_remise = 0;
		var frais_port = document.getElementById('Frais_Port').value;
		var escompte = document.getElementById('Escompte').value;
		var acompte = document.getElementById('Acompte').value;
		var ref_com = document.getElementById('Ref_Com').value;
		var delai = document.getElementById('Delai').value;		

		if (isEmpty(ref_com)) { showWarning("Veuillez indiquer une rfrence commande !"); }
		else if (isEmpty(remise) || (type_remise=='P'?!isTaux(remise):!isPositiveOrNull(remise))) { showWarning("Remise incorrecte !"); }
		else if (isEmpty(frais_port) || !isPositiveOrNull(frais_port)) { showWarning("Frais de port incorrects !"); }
		else if (isEmpty(escompte) || !isTaux(escompte)) { showWarning("Taux d'escompte incorrect !"); }
		else if (isEmpty(acompte) || !isPositiveOrNull(acompte)) { showWarning("Montant d'acompte incorrect !"); }
		else if (!isEmpty(delai) && !isDate(delai)) { showWarning("Dlai de livraison incorrect !"); }
		else {

			var corps;

			if (mode=="C") {
				corps = cookie() +"&Page=Facturation/Affaires/creerCommande.tmpl&ContentType=xml&Affaire_Id="+ affaire_id +"&EtatAffaire="+ ParamValeur("EtatAffaire");
			}
			else {
				corps = cookie() +"&Page=Facturation/Affaires/modifierCommande.tmpl&ContentType=xml&Com_Id="+ com_id;
			}
            
            var montant_base = (editionTTC?document.getElementById('pttcMontantTTC').value:document.getElementById('MontantHT').value);
			if (type_remise=='P') {
				taux_remise = remise;
                montant_remise = (montant_base > 0 ? montant_base * taux_remise / 100 : 0);
			}
			else {
				taux_remise = (montant_base>0?remise/montant_base*100:0);
				montant_remise = remise;
			}

			corps += "&Taux_Remise="+ taux_remise +"&Frais_Port="+ frais_port +"&Escompte="+ escompte +"&Acompte="+ acompte +"&Montant_Remise="+ montant_remise;
			corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
			corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");
			corps += "&Total_HT="+ currentTotalHT;
			corps += "&Montant_TTC="+ currentMontantTTC;
			corps += "&Ref_Com="+ urlEncode(ref_com);
      corps += "&Taux_TVA_Port="+ urlEncode(tva_port);
			corps += "&Code_Tarif="+ document.getElementById('Code_Tarif').value;
			corps += "&Delai="+ (!isEmpty(delai)?prepareDateJava(delai):"");
			corps += "&Edition_TTC="+ (document.getElementById('Edition_TTC').checked?"1":"0");
			corps += "&Assujetti_TVA="+(assujettiTVA?1:0);
			corps += "&Num_TVA_Intra="+urlEncode(numTVA);
			corps += "&Regime_TVA="+document.getElementById("Regime_TVA").value;

			var p = requeteHTTP(corps);

			if (mode=="C") {
				var contenu = p.responseXML.documentElement;
				com_id = contenu.getAttribute("Com_Id");
				charger = false;
				chargerCommande();
			}

			if (mode=="M") {
				corps = cookie() +"&Page=Facturation/Affaires/saveArticleComTemp.tmpl&ContentType=xml&Com_Id="+ com_id;
				requeteHTTP(corps);
			}
			setModifie(false);

			ok = true;
		}

		return ok;

	} catch (e) {
  	recup_erreur(e);
	}
}


function calculTotaux() {
  try {

		var tree = document.getElementById("articles");
		document.getElementById('Edition_TTC').disabled = (tree.view==null || tree.view.rowCount>0);
		document.getElementById('Regime_TVA').disabled = (tree.view==null || tree.view.rowCount>0);
		
		var remise = parseFloat(document.getElementById('Remise').value);
		var acompte = parseFloat(document.getElementById('Acompte').value);
		var taux_escompte = parseFloat(document.getElementById('Escompte').value);
		var frais_port = parseFloat(document.getElementById('Frais_Port').value);
		var montant_acompte = parseFloat(document.getElementById('Acompte').value);

		if ((type_remise=='P'?isTaux(remise):isPositiveOrNull(remise)) && isTaux(taux_escompte) && isPositiveOrNull(frais_port)) {

			var montant_tva = 0;
			var montant_ht = 0;
			var montant_ttc = 0;

			if (tree.view!=null) {

				if (editionTTC) {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {
							var tva  = getTva(getCellText(tree,i,'ColCode_TVA'));
							montant_ttc += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * (tva/100) / (tva/100+1);
						}
					}
					
					var taux_remise = (type_remise=='P'?remise:(montant_ttc==0?0:remise/montant_ttc*100));

					var montant_remise = montant_ttc * parseFloat(taux_remise/100);				

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100) / (tva_port/100+1);

					var total_ht = montant_ttc - montant_tva - montant_remise + frais_port;			

					var total_ttc = montant_ttc - montant_remise + frais_port;

					currentMontantTTC = total_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(total_ttc * parseFloat(taux_escompte/100));

					var net_ttc = total_ttc - montant_escompte - acompte;

					document.getElementById('pttcMontantRemise').value = nf.format(montant_remise);
					document.getElementById('pttcMontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('pttcTVA').value = nf.format(montant_tva);
					document.getElementById('pttcMontantTTC').value = nf.format(montant_ttc);
					document.getElementById('pttcMontantAcompte').value = nf.format(acompte);
					document.getElementById('pttcMontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('pttcTotalTTC').value = nf.format(total_ttc);
					document.getElementById('pttcNetTTC').value = nf.format(net_ttc);
				}				
				else {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {						
							montant_ht += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * getTva(getCellText(tree,i,'ColCode_TVA'))/100;
						}
					}
					
					var taux_remise = (type_remise=='P'?remise:(montant_ht==0?0:remise/montant_ht*100));

					var montant_remise = montant_ht * parseFloat(taux_remise/100);

					var total_ht = montant_ht * (1 - parseFloat(taux_remise/100)) + frais_port;

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100);

					montant_ttc = total_ht + montant_tva;

					currentMontantTTC = montant_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(montant_ttc * parseFloat(taux_escompte/100));

					var total_ttc = montant_ttc - montant_escompte - acompte;

					document.getElementById('MontantHT').value = nf.format(montant_ht);
					document.getElementById('MontantRemise').value = nf.format(montant_remise);
					document.getElementById('MontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('TotalHT').value = nf.format(total_ht);
					document.getElementById('TVA').value = nf.format(montant_tva);
					document.getElementById('MontantTTC').value = nf.format(montant_ttc);
					document.getElementById('MontantAcompte').value = nf.format(acompte);
					document.getElementById('MontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('TotalTTC').value = nf.format(total_ttc);					
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function afterRefreshArticles() {
	try {

		calculTotaux();
		scrollToRank();

	} catch (e) {
  	recup_erreur(e);
	}
}


function scrollToRank() {
	try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.view.rowCount>0 && currentRank>0) {

			var tb = document.getElementById("articles").treeBoxObject;
			var i = 0;
			var trouve = false;

			while (!trouve && i<tree.view.rowCount) {

				if (parseIntBis(getCellText(tree,i,'ColRank'))>=currentRank) {
					tb.ensureRowIsVisible(i);
					trouve = true;
				}

				i++;
			}
			if (!trouve) tb.ensureRowIsVisible(tree.view.rowCount-1);
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function demandeEnregistrement() {
  try {

		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes  la commande ?")) {
				enregistrerCommande();
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelCommande').setAttribute("label","Commande (modifie)");
			document.getElementById('bVisualiser').disabled = true;
			document.getElementById('bValiderCommande').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelCommande').setAttribute("label","Commande");
			document.getElementById('bVisualiser').disabled = false;
			document.getElementById('bValiderCommande').disabled = (etat_commande=='V');
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function init_tree() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_com_client.tmpl&ContentType=xml&Com_Id="+ com_id;
    load_rdf_async('articles', getUrlOpeneas(paramlist),chargerCommande);

  } catch (e) {
    recup_erreur(e);
  }
}

function delete_tree() {
  try {

    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();

  } catch (e) {
    recup_erreur(e);
  }
}


function nouvelleCommande() {
  try {

		var qVenteTTC = new QueryHttp("Config/gestion_commerciale/preferences/getParam.tmpl"); 
		var result = qVenteTTC.execute();

		var venteTTC = (result.responseXML.documentElement.getAttribute('Vente_TTC')==1);

		document.getElementById('Edition_TTC').checked = venteTTC;
		document.getElementById("Regime_TVA").value = "G";
		changerTypeEdition(venteTTC);

		mode = "C";

		document.getElementById('Ref_Com').value = "";
		document.getElementById('Commentaires').value = "";
		document.getElementById('Date_Com').value = "";
		document.getElementById('Imp_Com').checked = false;
		document.getElementById('Remise').value = "0.00";
		document.getElementById('Acompte').value = "0.00";
		document.getElementById('Escompte').value = "0.00";
		document.getElementById('Frais_Port').value = "0.00";
		document.getElementById('Delai').value = "";

		document.getElementById('MontantHT').value = "0.00";
		document.getElementById('MontantRemise').value = "0.00";
		document.getElementById('MontantFrais_Port').value = "0.00";
		document.getElementById('TotalHT').value = "0.00";
		document.getElementById('TVA').value = "0.00";
		document.getElementById('MontantTTC').value = "0.00";
		document.getElementById('MontantEscompte').value = "0.00";
		document.getElementById('MontantAcompte').value = "0.00";
		document.getElementById('TotalTTC').value = "0.00";
		
		document.getElementById('pttcMontantRemise').value = "0.00";
		document.getElementById('pttcMontantFrais_Port').value = "0.00";
		document.getElementById('pttcTVA').value = "0.00";
		document.getElementById('pttcMontantTTC').value = "0.00";
		document.getElementById('pttcMontantEscompte').value = "0.00";
		document.getElementById('pttcMontantAcompte').value = "0.00";
		document.getElementById('pttcTotalTTC').value = "0.00";
		document.getElementById('pttcNetTTC').value = "0.00";

		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";

		var corps = cookie() +"&Page=Facturation/Affaires/getDefaultCommande.tmpl&ContentType=xml&Client_Id="+ client_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;
		document.getElementById('Remise').value = contenu.getAttribute("Remise");
		document.getElementById('Code_Tarif').value = contenu.getAttribute("Code_Tarif");
		document.getElementById('lblTarif').value = contenu.getAttribute("Label_Tarif");

		ajouterLigne("I");

		delete_tree();

		setModifie(false);
		document.getElementById('bVisualiser').disabled = true;

    document.getElementById('Ref_Com').focus();

   	listeTVA();

	} catch (e) {
  	recup_erreur(e);
  }
}


function chargerCommande() {
  try {

		mode = "M";

		var corps = cookie() +"&Page=Facturation/Affaires/getCommande.tmpl&ContentType=xml&Com_Id="+ com_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		document.getElementById('Remise').value = contenu.getAttribute('Remise');
		type_remise = contenu.getAttribute('Type_Remise');
		document.getElementById("Regime_TVA").value = contenu.getAttribute('Regime_TVA');
		document.getElementById('bRemise').setAttribute("label", (type_remise=='P'?"%":"\u20AC"));
		document.getElementById('Escompte').value = contenu.getAttribute('Escompte');
		document.getElementById('Acompte').value = contenu.getAttribute('Acompte');
		document.getElementById('Frais_Port').value = contenu.getAttribute('Frais_Port');
    tva_port = contenu.getAttribute('Taux_TVA_Port');
		document.getElementById('Commentaires').value = contenu.getAttribute('Commentaires');
		document.getElementById('Imp_Com').checked = contenu.getAttribute('Imp_Com')=="1";
		document.getElementById('Date_Com').value = contenu.getAttribute('Date_Com');
		document.getElementById('Ref_Com').value = contenu.getAttribute('Ref_Com');
		document.getElementById('Code_Tarif').value = contenu.getAttribute('Code_Tarif');
		document.getElementById('lblTarif').value = contenu.getAttribute('Label_Tarif');
		document.getElementById('Delai').value = contenu.getAttribute('Delai');
		
		var typeEdition = (contenu.getAttribute('Edition_TTC')=="1");
				
		document.getElementById('Edition_TTC').checked = typeEdition;

		document.getElementById('Creation').label = "Commande cre le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Commande N "+ contenu.getAttribute('Ref_Com');
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		setModifie(false);

		etat_commande = contenu.getAttribute("Etat");

		if (etat_commande=='V') {
			disableAll();
		}
		else if (initLigne) {
			ajouterLigne("I");
			initLigne = false;
		}

		changerTypeEdition(typeEdition);
		
		if (charger) {
    	listeTVA();
    }
    charger=false;

	} catch (e) {
    recup_erreur(e);
  }
}

function init_tree_temp() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_com_client.tmpl&ContentType=xml&Com_Id="+ com_id +"&Temp=true";
    load_rdf_async('articles', getUrlOpeneas(paramlist), afterRefreshArticles);

  } catch (e) {
    recup_erreur(e);
  }
}

function visualiserCommande() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("La commande ne contient aucune ligne !");
		}
		else {

			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&EtatAffaire="+ urlEncode(ParamValeur("EtatAffaire"));
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));
			param_retour += "&Code_Pays_Liv="+ urlEncode(ParamValeur("Code_Pays_Liv"));
			param_retour += "&Assujetti_TVA="+ assujettiTVA;
			param_retour += "&Num_TVA_Intra="+ urlEncode(numTVA);

			var page = "chrome://opensi/content/facturation/user/affaires/com_client.xul?"+ cookie() +"&Com_Id="+ com_id + "&Affaire_Id="+ ParamValeur("Affaire_Id") +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function editerCommentaire() {
  try {

		var tree = document.getElementById("articles");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var rank = getCellText(tree,tree.currentIndex,'ColRank');

			var url = "chrome://opensi/content/facturation/user/affaires/commentaire.xul?"+ cookie() +"&Com_Id="+ com_id +"&Rank="+ rank;
    	window.openDialog(url,'','chrome,modal,centerscreen');

			delete_tree();
			init_tree_temp();
			ajouterLigne("I");
			setModifie(true);
		}
		else {
			showWarning("Aucun article ou commentaire slectionn !");
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function evaluer(elem, ev) {	
	try {
		
		if (ev.keyCode==13) {			
			var nf4 = new NumberFormat("0.00##", false);
			elem.value = nf4.format(calcExpr(elem.value));
		}
		
	}	catch(e) {
		recup_erreur(e);
	}
}


function changerTypeEdition(chgType) {
	try {

		editionTTC = chgType;
		
		if (editionTTC) {
			document.getElementById('ColTotal').setAttribute("label", "Total TTC");
			document.getElementById('ColPU').setAttribute("label", "P.U TTC");
			document.getElementById('lblFrais_Port').value = "Frais de port (ttc) :";
			document.getElementById('lblPU').value = "P.U TTC :";
			document.getElementById('piedTTC').collapsed = false;
			document.getElementById('piedHT').collapsed = true;
		}
		else {
			document.getElementById('ColTotal').setAttribute("label", "Total HT");
			document.getElementById('ColPU').setAttribute("label", "P.U HT");
			document.getElementById('lblFrais_Port').value = "Frais de port (ht) :";
			document.getElementById('lblPU').value = "P.U HT :";
			document.getElementById('piedTTC').collapsed = true;
			document.getElementById('piedHT').collapsed = false;			
		}
		
		calculTotaux();

	}	catch(e) {
		recup_erreur(e);
	}
}


function choisirMentions() {
  try {
  	
  	var ok = true;
  	
  	if (mode=="C") {
			ok = enregistrerCommande();
		}

		if (ok) {
			var url = "chrome://opensi/content/facturation/user/commun/popup-choix_mentions.xul?"+ cookie() +"&Type_Doc=Com_Client&Doc_Id="+ com_id;
    	window.openDialog(url,'','chrome,modal,centerscreen',setModifie);
		}		

	} catch (e) {
  	recup_erreur(e);
  }
}


function menuAffaires() {
  try {

    window.location = "chrome://opensi/content/facturation/user/affaires/menu_affaires.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_affaire() {
  try {

    window.location = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Mode=M&Affaire_Id="+ affaire_id;

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}
