/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/formatter.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/lib_tva.js");

var facture_id;
var client_id;
var affaire_id;
var mode;
var com_id; // peut tre une liste d'identifiants de commandes spars par une virgule
var gen;
var mode_fact;
var tva_port = getTva(4);
var type_remise = 'P';
var editionTTC = false;
var currentTotalHT = 0;
var currentMontantTTC = 0;

var nf = new NumberFormat("0.00", false);


function init() {
  try {
  	var corps = cookie() +"&Page=Config/gestion_commerciale/preferences/getParam.tmpl&ContentType=xml";
		var p = requeteHTTP(corps);
		var contenu = p.responseXML.documentElement;
    
		var act_code_stats = (parseInt(contenu.getAttribute('Act_Code_Stats'))==1);
		if (!act_code_stats) {
			document.getElementById('ColCode_Stats').collapsed = true;
			document.getElementById('SplitCode_Stats').collapsed = true;
		}
		var prod_frais = (contenu.getAttribute("Produit_Frais")=="1");
		document.getElementById('ColNumLot').collapsed = !prod_frais;
		document.getElementById('ColDLC').collapsed = !prod_frais;
		document.getElementById('ColNbPieces').collapsed = !prod_frais;
		document.getElementById('ColUnite').collapsed = !prod_frais;

		var paramlist = "&Page=Facturation/GetRDF/liste_reglements.tmpl&ContentType=xml";
    load_rdf_async('Mode_Reg', getUrlOpeneas(paramlist), init_2);

	} catch (e) {
  	recup_erreur(e);
	}
}


function init_2() {
	try {
        
		var com_valide = ParamValeur("ComValide");
		com_id = (com_valide.charAt(com_valide.length - 1) == "," ?
                        com_valide.substring(0, com_valide.length - 1) :
                        com_valide);
		affaire_id = ParamValeur("Affaire_Id");

		document.getElementById("Raison_Sociale").value = ParamValeur("Raison_Sociale");
		document.getElementById("Adresse_Fact").value = ParamValeur("Adresse_Fact");
		document.getElementById("CP_Fact").value = ParamValeur("CP_Fact");
		document.getElementById("Ville_Fact").value = ParamValeur("Ville_Fact");
		client_id = ParamValeur("Client_Id");
		document.getElementById("Client").setAttribute("label","Client N "+ client_id);
		document.getElementById("Affaire").setAttribute("label","Affaire N "+ ParamValeur("Num_Affaire"));
		document.getElementById("Nom_Affaire").value = ParamValeur("Nom_Affaire");
		document.getElementById("Responsable").value = ParamValeur("Responsable");
		mode_fact = ParamValeur("Type_Fact");

		window.parent.addEventListener("close",demandeEnregistrement,false);

		mode = ParamValeur("Mode");

		if (mode=="C") {
			creer_facture();
		}
		else {
			facture_id = ParamValeur("Facture_Id");
			charger_facture();
		}

		setModifie(false);

	} catch (e) {
    recup_erreur(e);
  }
}


function evaluer(elem, ev) {	
	try {
		
		if (ev.keyCode==13) {			
			var nf4 = new NumberFormat("0.00##", false);
			elem.value = nf4.format(calcExpr(elem.value));
		}
		
	}	catch(e) {
		recup_erreur(e);
	}
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur(e);
  }
}


function switchRemise() {
	try {

		if (type_remise=='P') {
			document.getElementById('bRemise').setAttribute("label", "\u20AC");
			type_remise = 'M';
		}
		else {
			document.getElementById('bRemise').setAttribute("label", "%");
			type_remise = 'P';
		}
		calculTotaux();
		setModifie(true);

	} catch (e) {
    recup_erreur(e);
  }
}


function disableAll() {
	try {

		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bSupprimer').disabled = true;
		document.getElementById('Acompte').disabled = true;
		document.getElementById('Escompte').disabled = true;
		document.getElementById('Frais_Port').disabled = true;
		document.getElementById('Remise').disabled = true;
		document.getElementById('Echeance').disabled = true;
		document.getElementById('Mode_Reg').disabled = true;
		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('bChoisirMentions').disabled = true;
		document.getElementById('bRemise').disabled = true;
		mode = "V";

	} catch (e) {
    recup_erreur(e);
  }
}


function creer_facture() {
  try {

		var corps = cookie() +"&Page=Facturation/Affaires/creerFacture.tmpl&ContentType=xml&Com_Id="+ com_id +"&Client_Id="+ client_id +"&Affaire_Id="+ affaire_id;

		if (mode_fact=="B") {
			corps += "&Bon_Id="+ ParamValeur("Bon_Id");
		}
        if (mode_fact=="C" || mode_fact == "G") {
          corps += "&Code_Pays="+ ParamValeur("Code_Pays");
        }

		var p = requeteHTTP(corps);
        var contenu = p.responseXML.documentElement;
        
        if (contenu.getAttribute("Est_Facturable") == 0) {
            showWarning("Les commandes s\u00E9lectionn\u00E9s sont d\u00E9j\u00E0 compl\u00E8tement factur\u00E9es");
            retour_affaire();
        } else {
            facture_id = contenu.getAttribute("Facture_Id");
            charger_facture();
        }
            
	} catch (e) {
  	    recup_erreur(e);
  }
}


function charger_facture() {
  try {

		init_tree_facture();

		mode = "M";

		var corps = cookie() +"&Page=Facturation/Affaires/getFacture.tmpl&ContentType=xml&Facture_Id="+ facture_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		var numero = contenu.getAttribute("Numero");

		if (numero==0) {
			gen = false;
		}
		else {
			gen = true;
			disableAll();
		}

		document.getElementById('Date_Facture').value = contenu.getAttribute("Date_Facture");
		document.getElementById('Commentaires').value = contenu.getAttribute("Commentaires");
		document.getElementById('Numero').value = contenu.getAttribute('Num_Entier');
		document.getElementById('Imp_Com').checked = contenu.getAttribute("Imp_Com")=="1";
		document.getElementById('Echeance').value = contenu.getAttribute("Echeance");
		document.getElementById('Mode_Reg').value = contenu.getAttribute("Mode_Reg");
		document.getElementById('Acompte').value = contenu.getAttribute("Acompte");
		document.getElementById('Escompte').value = contenu.getAttribute("Escompte");
		document.getElementById('Remise').value = contenu.getAttribute("Remise");
		type_remise = contenu.getAttribute('Type_Remise');
		document.getElementById('bRemise').setAttribute("label", (type_remise=='P'?"%":"\u20AC"));
		document.getElementById('Frais_Port').value = contenu.getAttribute("Frais_Port");
		tva_port = contenu.getAttribute("Taux_TVA_Port");
		
		var typeEdition = (contenu.getAttribute('Edition_TTC')=="1");

		document.getElementById('Creation').label = "Facture cre le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Facture N "+ contenu.getAttribute('Num_Entier');
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		setModifie(false);
		
		changerTypeEdition(typeEdition);

	} catch (e) {
  	recup_erreur(e);
  }
}


function enregistrerFacture() {
  try {

		var corps = cookie() +"&Page=Facturation/Affaires/modifierFacture.tmpl&ContentType=xml&Facture_Id="+ facture_id;

		var echeance = document.getElementById('Echeance').value;
		var acompte = document.getElementById('Acompte').value;
		var escompte = document.getElementById('Escompte').value;
		var remise = document.getElementById('Remise').value;
		var taux_remise = 0;
		var montant_remise = 0;
		var frais_port = document.getElementById('Frais_Port').value;

		if (isEmpty(echeance)) {
			showWarning("Vous devez indiquer une date d'chance avant d'enregistrer la facture !");
		}
		else if (!isDate(echeance)) {
			showWarning("Date d'chance incorrecte !");
		}
		else if (isEmpty(acompte) || !isPositiveOrNull(acompte)) { showWarning("Montant d'acompte incorrect !"); }
		else if (isEmpty(frais_port) || !isPositiveOrNull(frais_port)) { showWarning("Montant des frais de port incorrect !"); }
		else if (isEmpty(remise) || (type_remise=='P'?!isTaux(remise):!isPositiveOrNull(remise))) { showWarning("Remise incorrecte !"); }
		else if (isEmpty(escompte) || !isPositiveOrNull(escompte)) { showWarning("Taux d'escompte incorrect !"); }
		else {
		
			if (type_remise=='P') {
				taux_remise = remise;
			}
			else {
				var montant_base = (editionTTC?document.getElementById('pttcMontantTTC').value:document.getElementById('MontantHT').value);
				taux_remise = (montant_base>0?remise/montant_base*100:0);
				montant_remise = remise;
			}
		
			corps += "&Affaire_Id="+ affaire_id;
			corps += "&Commentaires="+ urlEncode(document.getElementById('Commentaires').value);
			corps += "&Imp_Com="+ (document.getElementById('Imp_Com').checked?"1":"0");
			corps += "&Mode_Reg="+ urlEncode(document.getElementById('Mode_Reg').value);
			corps += "&Echeance="+ prepareDateJava(echeance);
			corps += "&Acompte="+ acompte;
			corps += "&Escompte="+ escompte;
			corps += "&Frais_Port="+ frais_port;
			corps += "&Taux_Remise="+ taux_remise;
			corps += "&Montant_Remise="+ montant_remise;
			corps += "&Total_HT="+ currentTotalHT;
			corps += "&Montant_TTC="+ currentMontantTTC;

			requeteHTTP(corps);

			setModifie(false);
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function supprimerFacture() {
	try {

		var qSupFact = new QueryHttp("Facturation/Affaires/supprimerFacture.tmpl");
		qSupFact.setParam("Facture_Id", facture_id);
		qSupFact.execute();
		
		retour_affaire();
	
	} catch (e) {
  	recup_erreur(e);
  }
}


function demandeEnregistrement() {
  try {

		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes  la facture ?")) {
				enregistrerFacture();
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelFacture').setAttribute("label","Facture (modifie)");
			document.getElementById('bVisualiser').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelFacture').setAttribute("label","Facture");
			document.getElementById('bVisualiser').disabled = false;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function init_tree_facture() {
  try {

    var paramlist = "&Page=Facturation/GetRDF/articles_facture.tmpl&ContentType=xml&Facture_Id="+ facture_id;
    load_rdf_async('articles', getUrlOpeneas(paramlist), calculTotaux);

  } catch (e) {
    recup_erreur(e);
  }
}


function delete_tree_facture() {
  try {

    var database = document.getElementById("articles").database;
    var datasources = database.GetDataSources();
    while (datasources.hasMoreElements()) {
      var ds = datasources.getNext();
      database.RemoveDataSource(ds);
    }
		document.getElementById('articles').builder.rebuild();

  } catch (e) {
    recup_erreur(e);
  }
}


function visualiserFacture() {
  try {

		var numero = document.getElementById("Numero").value;
		var tree = document.getElementById("articles");
		var frais_port = document.getElementById("Frais_Port");

		if ((tree.view==null || tree.view.rowCount<=0) && frais_port==0) {
			showWarning("La facture ne contient aucune ligne !");
		}
		else if (gen || window.confirm("Confirmez-vous la gnration de la facture ?\n(Attention la facture gnre ne pourra plus tre modifie !)")) {
			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&ComValide="+ ParamValeur("ComValide");
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

			var page = "chrome://opensi/content/facturation/user/affaires/facture.xul?"+ cookie() +"&Com_Id="+ com_id +"&Affaire_Id="+ affaire_id +"&Facture_Id="+ facture_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function calculTotaux() {
  try {

		var remise = parseFloat(document.getElementById('Remise').value);
		var taux_escompte = parseFloat(document.getElementById('Escompte').value);
		var frais_port = parseFloat(document.getElementById('Frais_Port').value);
		var acompte = parseFloat(document.getElementById('Acompte').value);

		if ((type_remise=='P'?isTaux(remise):isPositiveOrNull(remise)) && isTaux(taux_escompte) && isPositiveOrNull(frais_port) && isPositiveOrNull(acompte)) {

			var tree = document.getElementById("articles");

			var montant_tva = 0;
			var montant_ht = 0;
			var montant_ttc = 0;

			if (tree.view!=null) {

				if (editionTTC) {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {
							var tva  = getTva(getCellText(tree,i,'ColCode_TVA'));
							montant_ttc += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * (tva/100) / (tva/100+1);
						}
					}
					
					var taux_remise = (type_remise=='P'?remise:(montant_ttc==0?0:remise/montant_ttc*100));

					var montant_remise = montant_ttc * parseFloat(taux_remise/100);				

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100) / (tva_port/100+1);

					var total_ht = montant_ttc - montant_tva - montant_remise + frais_port;			

					var total_ttc = montant_ttc - montant_remise + frais_port;

					currentMontantTTC = total_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(total_ttc * parseFloat(taux_escompte/100));

					var net_ttc = total_ttc - montant_escompte - acompte;

					document.getElementById('pttcMontantRemise').value = nf.format(montant_remise);
					document.getElementById('pttcMontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('pttcTVA').value = nf.format(montant_tva);
					document.getElementById('pttcMontantTTC').value = nf.format(montant_ttc);
					document.getElementById('pttcMontantAcompte').value = nf.format(acompte);
					document.getElementById('pttcMontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('pttcTotalTTC').value = nf.format(total_ttc);
					document.getElementById('pttcNetTTC').value = nf.format(net_ttc);
				}				
				else {
					for (var i=0;i<tree.view.rowCount;i++) {

						if (getCellText(tree,i,'ColType_Ligne')!="C") {						
							montant_ht += parseFloat(getCellText(tree,i,'ColTotal'));
          		montant_tva += parseFloat(getCellText(tree,i,'ColTotal')) * getTva(getCellText(tree,i,'ColCode_TVA'))/100;
						}
					}
					
					var taux_remise = (type_remise=='P'?remise:(montant_ht==0?0:remise/montant_ht*100));

					var montant_remise = montant_ht * parseFloat(taux_remise/100);

					var total_ht = montant_ht * (1 - parseFloat(taux_remise/100)) + frais_port;

					montant_tva = montant_tva * (1 - parseFloat(taux_remise/100)) + frais_port * (tva_port/100);

					montant_ttc = total_ht + montant_tva;

					currentMontantTTC = montant_ttc;
					currentTotalHT = total_ht;

					var montant_escompte = nf.format(montant_ttc * parseFloat(taux_escompte/100));

					var total_ttc = montant_ttc - montant_escompte - acompte;

					document.getElementById('MontantHT').value = nf.format(montant_ht);
					document.getElementById('MontantRemise').value = nf.format(montant_remise);
					document.getElementById('MontantFrais_Port').value = nf.format(frais_port);
					document.getElementById('TotalHT').value = nf.format(total_ht);
					document.getElementById('TVA').value = nf.format(montant_tva);
					document.getElementById('MontantTTC').value = nf.format(montant_ttc);
					document.getElementById('MontantAcompte').value = nf.format(acompte);
					document.getElementById('MontantEscompte').value = nf.format(montant_escompte);
					document.getElementById('TotalTTC').value = nf.format(total_ttc);					
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function changerTypeEdition(chgType) {
	try {

		editionTTC = chgType;
		
		if (editionTTC) {
			document.getElementById('ColTotal').setAttribute("label", "Total TTC");
			document.getElementById('ColPU').setAttribute("label", "P.U TTC");
			document.getElementById('lblFrais_Port').value = "Frais de port (ttc) :";
			document.getElementById('piedTTC').collapsed = false;
			document.getElementById('piedHT').collapsed = true;
		}
		else {
			document.getElementById('ColTotal').setAttribute("label", "Total HT");
			document.getElementById('ColPU').setAttribute("label", "P.U HT");
			document.getElementById('lblFrais_Port').value = "Frais de port (ht) :";
			document.getElementById('piedTTC').collapsed = true;
			document.getElementById('piedHT').collapsed = false;			
		}
		
		calculTotaux();

	}	catch(e) {
		recup_erreur(e);
	}
}


function choisirMentions() {
  try {
  	
  	var url = "chrome://opensi/content/facturation/user/commun/popup-choix_mentions.xul?"+ cookie() +"&Type_Doc=Facture&Doc_Id="+ facture_id;
    window.openDialog(url,'','chrome,modal,centerscreen',setModifie);	

	} catch (e) {
  	recup_erreur(e);
  }
}


function menuAffaires() {
  try {

    window.location = "chrome://opensi/content/facturation/user/affaires/menu_affaires.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_affaire() {
  try {

    window.location = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Mode=M&Affaire_Id="+ affaire_id;

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}
