/******************************************************************************/
/* OpenSi : Outils libres de gestion d'entreprise                             */
/* Copyright (C) 2003 Speedinfo.fr S.A.R.L.                                   */
/* Contact: contact@opensi.org                                                */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/


jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/verif.js");
jsLoader.loadSubScript("chrome://opensi/content/libs/arbres.js");


var bon_id;
var client_id;
var affaire_id;
var mode;
var com_id;
var etat_bon;
var current_code_pays_liv;

var aBon = new Arbre('fact', 'articles_bon.tmpl', 'bon_livraison');
var aCom = new Arbre('fact', 'articles_a_livrer.tmpl', 'commande');
		

function init() {
  try {
  	
  	var qProduitsFrais = new QueryHttp("Config/gestion_commerciale/preferences/getParam.tmpl");
		var result = qProduitsFrais.execute();
		var prod_frais = (result.responseXML.documentElement.getAttribute("Produit_Frais")=="1");
		document.getElementById('prod_frais_entree').collapsed = !prod_frais;
		document.getElementById('prod_frais_sortie').collapsed = !prod_frais;
		document.getElementById('ColNumLotDev').collapsed = !prod_frais;
		document.getElementById('ColDLCDev').collapsed = !prod_frais;
		document.getElementById('ColNbPiecesDev').collapsed = !prod_frais;
		document.getElementById('ColNumLotLiv').collapsed = !prod_frais;
		document.getElementById('ColDLCLiv').collapsed = !prod_frais;
		document.getElementById('ColNbPiecesLiv').collapsed = !prod_frais;

		com_id = ParamValeur("ComValide");
		affaire_id = ParamValeur("Affaire_Id");
		
		aCom.setParam('Com_Id', com_id);		

		document.getElementById("Raison_Sociale").value = ParamValeur("Raison_Sociale");
		document.getElementById("Adresse_Fact").value = ParamValeur("Adresse_Fact");
		document.getElementById("CP_Fact").value = ParamValeur("CP_Fact");
		document.getElementById("Ville_Fact").value = ParamValeur("Ville_Fact");
		client_id = ParamValeur("Client_Id");
		document.getElementById("Client").setAttribute("label","Client N "+ client_id);
		document.getElementById("Affaire").setAttribute("label","Affaire N "+ ParamValeur("Num_Affaire"));
		document.getElementById("Nom_Affaire").value = ParamValeur("Nom_Affaire");
		document.getElementById("Responsable").value = ParamValeur("Responsable");

		document.getElementById("Civ_Inter_Liv").value = ParamValeur("Civ_Inter_Liv");
		document.getElementById("Civ_Inter_Courte_Liv").value = ParamValeur("Civ_Inter_Courte_Liv");
		document.getElementById("Nom_Inter_Liv").value = ParamValeur("Nom_Inter_Liv");
		document.getElementById("Prenom_Inter_Liv").value = ParamValeur("Prenom_Inter_Liv");
		document.getElementById("Tel_Inter_Liv").value = ParamValeur("Tel_Inter_Liv");
		document.getElementById("Fax_Inter_Liv").value = ParamValeur("Fax_Inter_Liv");
		document.getElementById("Email_Inter_Liv").value = ParamValeur("Email_Inter_Liv");

		window.parent.addEventListener("close",demandeEnregistrement,false);

		mode = ParamValeur("Mode");

		if (mode=="C") {
			nouveau_bon();
		}
		else {
			bon_id = ParamValeur("Bon_Id");
			aBon.setParam('Bon_Id', bon_id);
			aCom.setParam('Bon_Id', bon_id);
			charger_bon();
		}
		
		disableAjouter(true,false);
		disableEnlever(true,false);

	} catch (e) {
  	recup_erreur(e);
	}
}


function desinit() {
	try {

		window.parent.removeEventListener("close",demandeEnregistrement,false);

	} catch (e) {
    recup_erreur(e);
  }
}


function reporterQteEntree() {
	try {

		var tree = document.getElementById('commande');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById("NumLotEntree").value = getCellText(tree,tree.currentIndex,'ColNumLotDev');
			document.getElementById("DLCEntree").value = getCellText(tree,tree.currentIndex,'ColDLCDev');
			document.getElementById("NbPiecesEntree").value = getCellText(tree,tree.currentIndex,'ColNbPiecesDev');
			document.getElementById("QteEntree").value = getCellText(tree,tree.currentIndex,'ColQuantiteDev');
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function reporterQteSortie() {
	try {

		var tree = document.getElementById('bon_livraison');

		if (tree.view!=null && tree.currentIndex!=-1) {
			document.getElementById("NbPiecesSortie").value = getCellText(tree,tree.currentIndex,'ColNbPiecesLiv');
			document.getElementById("QteSortie").value = getCellText(tree,tree.currentIndex,'ColQuantiteLiv');
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function disableAjouter(b,arbre) {
	try {

		var tree = document.getElementById('commande');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1 && mode!="V")) {
			document.getElementById('bAjouter').disabled = b;
			document.getElementById('NumLotEntree').disabled = b;
			document.getElementById('DLCEntree').disabled = b;
			document.getElementById('NbPiecesEntree').disabled = b;
			document.getElementById('QteEntree').disabled = b;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function disableEnlever(b,arbre) {
	try {

		var tree = document.getElementById('bon_livraison');

		if (!arbre || (tree.view!=null && tree.currentIndex!=-1 && mode!="V")) {
			document.getElementById('bEnlever').disabled = b;
			document.getElementById('NbPiecesSortie').disabled = b;
			document.getElementById('QteSortie').disabled = b;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function disableAll() {
	try {

		document.getElementById('bToutEnlever').disabled = true;
		document.getElementById('bToutAjouter').disabled = true;
		disableAjouter(true,false);
		disableEnlever(true,false);
		document.getElementById('bEnregistrer').disabled = true;
		document.getElementById('bValider').disabled = true;
		document.getElementById('Commentaires').disabled = true;
		document.getElementById('Imp_Com').disabled = true;
		document.getElementById('bChoisirMentions').disabled = true;
		document.getElementById('Nb_Colis').disabled = true;
		document.getElementById('Frais_Sup').disabled = true;
		document.getElementById('chercher_adresse').collapsed = true;
		document.getElementById('chercher_inter').collapsed = true;
		document.getElementById('corps_commande').collapsed = true;
		document.getElementById('corps_transfert').collapsed = true;
		document.getElementById('titre_corps').collapsed = true;
		mode = "V";

	} catch (e) {
    recup_erreur(e);
  }
}


function nouveau_bon() {
  try {

		mode = "C";

		document.getElementById('bToutEnlever').disabled = true;
		disableAjouter(true,false);
		disableEnlever(true,false);

		document.getElementById('Commentaires').value = "";
		document.getElementById('Date_Liv').value = "";
		document.getElementById('Numero').value = "";
		document.getElementById('Imp_Com').checked = false;
		document.getElementById('Nb_Colis').value = "";
		document.getElementById('Frais_Sup').value = "0.00";

		document.getElementById('Creation').label = "";
		document.getElementById('Modification').label = "";
		document.getElementById('Creation').collapsed = true;
		document.getElementById('Modification').collapsed = true;
		document.getElementById('Fiche').label = "";
		document.getElementById('Etat').label = "En cours";

		var corps = cookie() +"&Page=Facturation/Affaires/getDefaultAdresse.tmpl&ContentType=xml&Affaire_Id="+ affaire_id;

		var p = requeteHTTP(corps);

		var contenu = p.responseXML.documentElement;

		document.getElementById('Denomination_Liv').value = contenu.getAttribute('Raison_Sociale');
		document.getElementById('Adresse_1_Liv').value = contenu.getAttribute('Adresse');
		document.getElementById('Adresse_2_Liv').value = contenu.getAttribute('Comp_Adresse');
		document.getElementById('Adresse_3_Liv').value = contenu.getAttribute('Adresse_3');
		document.getElementById('Code_Postal_Liv').value = contenu.getAttribute('Code_Postal');
		document.getElementById('Ville_Liv').value = contenu.getAttribute('Ville');
		document.getElementById('Pays_Liv').value = contenu.getAttribute('Pays');
		document.getElementById('Code_Pays_Liv').value = contenu.getAttribute('Code_Pays');

		document.getElementById('Civ_Inter_Liv').value = contenu.getAttribute("Civ_Inter_Liv");
		document.getElementById('Civ_Inter_Courte_Liv').value = contenu.getAttribute("Civ_Inter_Courte_Liv");
		document.getElementById('Nom_Inter_Liv').value = contenu.getAttribute("Nom_Inter_Liv");
		document.getElementById('Prenom_Inter_Liv').value = contenu.getAttribute("Prenom_Inter_Liv");
		document.getElementById('Tel_Inter_Liv').value = contenu.getAttribute("Tel_Inter_Liv");
		document.getElementById('Fax_Inter_Liv').value = contenu.getAttribute("Fax_Inter_Liv");
		document.getElementById('Email_Inter_Liv').value = contenu.getAttribute("Email_Inter_Liv");

		aBon.deleteTree();
		aCom.initTree();

		setModifie(false);
		document.getElementById('bVisualiser').disabled = true;
		document.getElementById('bValider').disabled = true;
		document.getElementById('bSupprimer').collapsed = true;
		document.getElementById('bAnnuler').collapsed = true;
		document.getElementById('bColisage').disabled = true;

	} catch (e) {
  	recup_erreur(e);
  }
}


function charger_bon() {
  try {

		var corps = cookie() +"&Page=Facturation/Affaires/loadArticleBonTemp.tmpl&ContentType=xml&Bon_Id="+ bon_id;

		requeteHTTP(corps);

		mode = "M";
		document.getElementById('bToutEnlever').disabled = false;

		var qbl = new QueryHttp("Facturation/Affaires/getBonLivraison.tmpl");
		qbl.setParam("Bon_Id",bon_id);
		var p = qbl.execute();
		var contenu = p.responseXML.documentElement;

		etat_bon = contenu.getAttribute("Etat");

		if (etat_bon=="V") {
			disableAll();
			document.getElementById('Etat').value = "Valid";
			document.getElementById('bSupprimer').collapsed = true;
			document.getElementById('bAnnuler').collapsed = false;
			if (contenu.getAttribute("Facture_Id")!="0") {
				document.getElementById('bAnnuler').disabled = true;
			}
		}
		else if (etat_bon=="A") {
			disableAll();
			document.getElementById('Etat').value = "Annul";
			document.getElementById('bSupprimer').collapsed = true;
			document.getElementById('bAnnuler').collapsed = true;
		}
		else {
			document.getElementById('Etat').value = "En cours";
			document.getElementById('bAnnuler').collapsed = true;
			document.getElementById('bSupprimer').collapsed = false;
		}

		document.getElementById('Date_Liv').value = contenu.getAttribute("Date_Liv");
		document.getElementById('Denomination_Liv').value = contenu.getAttribute("Nom_Liv");
		document.getElementById('Adresse_1_Liv').value = contenu.getAttribute("Adresse_Liv");
		document.getElementById('Adresse_2_Liv').value = contenu.getAttribute("Comp_Adresse_Liv");
		document.getElementById('Adresse_3_Liv').value = contenu.getAttribute("Adresse_3_Liv");
		document.getElementById('Code_Postal_Liv').value = contenu.getAttribute("CP_Liv");
		document.getElementById('Ville_Liv').value = contenu.getAttribute("Ville_Liv");		
		document.getElementById('Pays_Liv').value = contenu.getAttribute("Pays_Liv");
		document.getElementById('Code_Pays_Liv').value = contenu.getAttribute("Code_Pays_Liv");
		document.getElementById('Commentaires').value = contenu.getAttribute("Commentaires");
		document.getElementById('Numero').value = contenu.getAttribute("Num_Entier");
		document.getElementById('Imp_Com').checked = contenu.getAttribute("Imp_Com")=="1";
		document.getElementById('Nb_Colis').value = contenu.getAttribute("Nb_Colis");
		document.getElementById('Frais_Sup').value = contenu.getAttribute("Frais_Sup");

		document.getElementById('Civ_Inter_Liv').value = contenu.getAttribute("Civ_Inter_Liv");
		document.getElementById('Nom_Inter_Liv').value = contenu.getAttribute("Nom_Inter_Liv");
		document.getElementById('Prenom_Inter_Liv').value = contenu.getAttribute("Prenom_Inter_Liv");
		document.getElementById('Tel_Inter_Liv').value = contenu.getAttribute("Tel_Inter_Liv");
		document.getElementById('Fax_Inter_Liv').value = contenu.getAttribute("Fax_Inter_Liv");
		document.getElementById('Email_Inter_Liv').value = contenu.getAttribute("Email_Inter_Liv");

		document.getElementById('Creation').label = "Bon de livraison cr le "+ contenu.getAttribute('Date_Creation') +" par "+ contenu.getAttribute('Login_Createur');
		document.getElementById('Modification').label = "Dernire modification le "+ contenu.getAttribute('Date_Maj') +" par "+ contenu.getAttribute('Login_Maj');
		document.getElementById('Fiche').label = "Bon N "+ contenu.getAttribute('Num_Entier');
		document.getElementById('Creation').collapsed = false;
		document.getElementById('Modification').collapsed = false;

		aCom.initTree();
		aBon.initTree();

		setModifie(false);

	} catch (e) {
  	recup_erreur(e);
  }
}


function enregistrerBon() {
  try {
  	
  	var ok=false;

		var corps;

		if (mode=="C") {
			corps = cookie() +"&Page=Facturation/Affaires/creerBonLivraison.tmpl&ContentType=xml";
		}
		else {
			corps = cookie() +"&Page=Facturation/Affaires/modifierBonLivraison.tmpl&ContentType=xml&Bon_Id="+ bon_id;
		}

		var denomination_liv = document.getElementById('Denomination_Liv').value;
		var adresse_1_liv = document.getElementById('Adresse_1_Liv').value;
		var adresse_2_liv = document.getElementById('Adresse_2_Liv').value;
		var adresse_3_liv = document.getElementById('Adresse_3_Liv').value;
		var code_postal_liv = document.getElementById('Code_Postal_Liv').value;
		var ville_liv = document.getElementById('Ville_Liv').value;
		var code_pays_liv = document.getElementById('Code_Pays_Liv').value;

		var civ_inter_liv = document.getElementById("Civ_Inter_Liv").value;
		var nom_inter_liv = document.getElementById("Nom_Inter_Liv").value;
		var prenom_inter_liv = document.getElementById("Prenom_Inter_Liv").value;
		var tel_inter_liv = document.getElementById("Tel_Inter_Liv").value;
		var fax_inter_liv = document.getElementById('Fax_Inter_Liv').value;
		var email_inter_liv = document.getElementById('Email_Inter_Liv').value;

		var nb_colis = document.getElementById('Nb_Colis').value;
		var frais_sup = document.getElementById('Frais_Sup').value;
		var commentaires = document.getElementById('Commentaires').value;
		var imp_com = (document.getElementById('Imp_Com').checked?"1":"0");

		corps += "&Nom_Liv="+ urlEncode(denomination_liv);
		corps += "&Affaire_Id="+ affaire_id;
		corps += "&Adresse_Liv="+ urlEncode(adresse_1_liv);
		corps += "&Comp_Adresse_Liv="+ urlEncode(adresse_2_liv);
		corps += "&Adresse_3_Liv="+ urlEncode(adresse_3_liv);
		corps += "&CP_Liv="+ urlEncode(code_postal_liv);
		corps += "&Ville_Liv="+ urlEncode(ville_liv);
		corps += "&Code_Pays_Liv="+ urlEncode(code_pays_liv);
		corps += "&Commentaires="+ urlEncode(commentaires);
		corps += "&Imp_Com="+ imp_com;
		corps += "&Nb_Colis="+ nb_colis;
		corps += "&Frais_Sup="+ frais_sup;
        corps += "&Commande_Id=" + com_id;

		corps += "&Civ_Inter_Liv="+ urlEncode(civ_inter_liv);
		corps += "&Nom_Inter_Liv="+ urlEncode(nom_inter_liv);
		corps += "&Prenom_Inter_Liv="+ urlEncode(prenom_inter_liv);
		corps += "&Tel_Inter_Liv="+ urlEncode(tel_inter_liv);
		corps += "&Fax_Inter_Liv="+ urlEncode(fax_inter_liv);
		corps += "&Email_Inter_Liv="+ urlEncode(email_inter_liv);

		if (isEmpty(denomination_liv)) {
			showWarning("Vous devez choisir une adresse de livraison avant d'enregistrer le bon !");
		}
		else if (!isEmpty(nb_colis) && !isPositiveOrNullInteger(nb_colis)) {
			showWarning("Nombre de colis incorrect !");
		}
		else if (isEmpty(frais_sup) || !isPositiveOrNull(frais_sup)) {
			showWarning("Frais de port supplmentaires incorrects !");
		}
		else {
			var p = requeteHTTP(corps);

			var contenu = p.responseXML.documentElement;

			if (mode=="C") {
				bon_id = contenu.getAttribute("Bon_Id");
				aBon.setParam('Bon_Id', bon_id);
				aCom.setParam('Bon_Id', bon_id);
				charger_bon();
			}

			if (mode=="M") {
				corps = cookie() +"&Page=Facturation/Affaires/saveArticleBonTemp.tmpl&ContentType=xml&Bon_Id="+ bon_id;
				requeteHTTP(corps);
			}

			setModifie(false);
			ok=true;
		}
		return ok;

	} catch (e) {
  	recup_erreur(e);
  }
}


function supprimerBon() {
  try {

		if (window.confirm("Confirmez-vous la suppression de ce bon de livraison ?")) {
			
			var qSupBL = new QueryHttp("Facturation/Affaires/supprimerBL.tmpl");
			qSupBL.setParam("Bon_Id", bon_id);
			qSupBL.execute();
			
			showMessage("Le bon de livraison a t supprim avec succs");
			
			retour_affaire();
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function ToutTransferer() {
  try {
  	
		if (mode=="C") {
			enregistrerBon();
		}

		corps = cookie() +"&Page=Facturation/Affaires/ajouterToutBon.tmpl&ContentType=xml&Bon_Id="+ bon_id +"&Com_Id="+ com_id;
		var p = requeteHTTP(corps);
		if (p.responseXML.documentElement.getAttribute("erreur")=="true") { showWarning("Certains articles n'ont pas pu tre transfrs car leur numro de lot est bloqu !"); }

		aCom.initTree();
		aBon.initTree();
		
		setModifie(true);

	} catch (e) {
  	recup_erreur(e);
	}
}


function ToutEnlever() {
  try {

		corps = cookie() +"&Page=Facturation/Affaires/enleverToutBon.tmpl&ContentType=xml&Bon_Id="+ bon_id;
		requeteHTTP(corps);

		aCom.initTree();
		aBon.initTree();
		
		setModifie(true);

	} catch (e) {
  	recup_erreur(e);
	}
}


function Ajouter() {
  try {

		var tree = document.getElementById("commande");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var ligne = getCellText(tree,tree.currentIndex,'ColLigneDev');
			var qteinit = getCellText(tree,tree.currentIndex,'ColQuantiteDev');
			var quantite = document.getElementById("QteEntree").value;
			
			var date_peremption = document.getElementById("DLCEntree").value;
			var num_lot = document.getElementById("NumLotEntree").value;
			var nb_pieces_init = getCellText(tree,tree.currentIndex,'ColNbPiecesDev');
			if (isEmpty(nb_pieces_init)) { nb_pieces_init = 0; }
			var nb_pieces = document.getElementById("NbPiecesEntree").value;
			
			var qCheckNumLot = new QueryHttp("Facturation/Suivi_Lot/checkNumLot.tmpl");
			qCheckNumLot.setParam("Num_Lot", num_lot);
			var result = qCheckNumLot.execute();
			if (result.responseXML.documentElement.getAttribute("blocage")=="true") { showWarning("Impossible de transfrer cet article car le numro de lot est bloqu !"); }
			
			else if (isEmpty(quantite)) { showWarning("Veuillez entrer une quantit  transfrer"); }
			else if (!checkQte(quantite)) { showWarning("Quantit incorrecte !"); }
			else if (!isEmpty(nb_pieces) && !isPositiveInteger(nb_pieces)) { showWarning("Nombre de pices incorrect !");	}
			else if (!isEmpty(date_peremption) && !isDate(date_peremption)) { showWarning("Date de premption incorrecte !");	}
			else {

				var continuer = true;

				if (parseFloat(qteinit)-parseFloat(quantite)<0) {
					continuer = window.confirm("La quantit  transfrer dpasse la quantit restant  livrer !\n\nVoulez-vous vraiment livrer plus que la quantit commande ?");
				}
				
				if (!isEmpty(nb_pieces)) {
					if (parseFloat(nb_pieces_init)-parseFloat(nb_pieces)<0) {
						continuer = window.confirm("Le nb de pices  transfrer dpasse le nb de pices restant  livrer !\n\nVoulez-vous vraiment livrer plus que le nb de pices command ?");
					}
				}

				if (continuer) {

					if (mode=="C") enregistrerBon();

					var corps = cookie() +"&Page=Facturation/Affaires/ajouterArticleBon.tmpl&ContentType=xml&Bon_Id="+ bon_id +"&Ligne="+ ligne +"&Quantite="+ quantite;
					corps+="&Num_Lot="+urlEncode(num_lot)+"&Nb_Pieces="+nb_pieces+"&Date_Peremption="+(!isEmpty(date_peremption)?prepareDateJava(date_peremption):"");
					
					requeteHTTP(corps, new XMLHttpRequest(), Ajouter_2);
				}
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}

function Ajouter_2() {
  try {

		aCom.initTree();
		aBon.initTree();
		
		disableAjouter(true,false);
		
		setModifie(true);

	} catch (e) {
  	recup_erreur(e);
	}
}


function Enlever() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view!=null && tree.currentIndex!=-1) {

			var ligne = getCellText(tree,tree.currentIndex,'ColLigneLiv');
			var qteinit = getCellText(tree,tree.currentIndex,'ColQuantiteLiv');
			var quantite = document.getElementById("QteSortie").value;
			var nb_pieces_init = getCellText(tree,tree.currentIndex,'ColNbPiecesLiv');
			if (isEmpty(nb_pieces_init)) { nb_pieces_init = 0; }
			var nb_pieces = document.getElementById("NbPiecesSortie").value;

			if (isEmpty(quantite)) {
				showWarning("Veuillez entrer une quantit  enlever");
			}
			else if (!checkQte(quantite)) {
				showWarning("Quantit incorrecte !");
			}
			else if (parseFloat(qteinit)-parseFloat(quantite)<0) {
				showWarning("La quantit  enlever ne peut dpasser la quantit prsente dans le bon de livraison !");
			}
			else if (!isEmpty(nb_pieces) && !isPositiveInteger(nb_pieces)) { showWarning("Nombre de pices incorrect !");	}
			else if (!isEmpty(nb_pieces) && (parseFloat(nb_pieces_init)-parseFloat(nb_pieces)<0)) {
				showWarning("Le nb de pices  enlever ne peut dpasser le nb de pices prsent dans le bon de livraison !");
			}
			else {
				corps = cookie() +"&Page=Facturation/Affaires/enleverArticleBon.tmpl&ContentType=xml&Bon_Id="+ bon_id +"&Ligne="+ ligne +"&QteInit="+ qteinit +"&Quantite="+ quantite+"&Nb_Pieces="+ nb_pieces;
				requeteHTTP(corps);

				aCom.initTree();
				aBon.initTree();
				
				disableEnlever(true,false);
				
				setModifie(true);
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function demandeEnregistrement() {
  try {

		if (document.getElementById("Modifie").value=="y") {
			if (window.confirm("Voulez-vous enregistrer les modifications apportes au bon de livraison ?")) {
				enregistrerBon();
			}
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function setModifie(m) {
  try {

		if (m) {
			document.getElementById('Modifie').value = "y";
			document.getElementById('labelBon').setAttribute("label","Bon de livraison (modifi)");
			document.getElementById('bValider').disabled = true;
			document.getElementById('bVisualiser').disabled = true;
			document.getElementById('bColisage').disabled = true;
			document.getElementById('bEditionBP').disabled = true;
		}
		else {
			document.getElementById('Modifie').value = "n";
			document.getElementById('labelBon').setAttribute("label","Bon de livraison");
			document.getElementById('bValider').disabled = (etat_bon=='V');
			document.getElementById('bValider').collapsed = (etat_bon=='V' || etat_bon=='A');
			document.getElementById('bVisualiser').disabled = false;
			document.getElementById('bVisualiser').collapsed = (etat_bon=='N');
			document.getElementById('bColisage').disabled = false;
			document.getElementById('bEditionBP').disabled = false;
		}

	} catch (e) {
  	recup_erreur(e);
	}
}


function visualiserBon() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de livraison ne contient aucune ligne !");
		}
		else {
			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&ComValide="+ ParamValeur("ComValide");
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

			var page = "chrome://opensi/content/facturation/user/affaires/bon_livraison.xul?"+ cookie();// +"&Solder="+ solder;
			page += "&Com_Id="+ com_id +"&Affaire_Id="+ affaire_id +"&Bon_Id="+ bon_id +"&ParamRetour="+ urlEncode(param_retour);
	  	window.location = page;
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function validerBon() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de livraison ne contient aucune ligne !");
		}
		else if (window.confirm("Confirmez-vous la validation du bon de livraison ?\n(Attention le bon de livraison valid ne pourra plus tre modifi !)")) {
			
			var solder = (document.getElementById('Solder').checked?"1":"0");
			
			var qValider = new QueryHttp("Facturation/Affaires/validerBonLivraison.tmpl");
			qValider.setParam('Client_Id', client_id);
			qValider.setParam('Com_Id', com_id);
			qValider.setParam('Bon_Id', bon_id);
			qValider.setParam('Solder', solder);
			var result = qValider.execute();
			
			if (result.responseXML.documentElement.getAttribute('code_erreur')=="1") {
				showWarning("Impossible de valider le bon de livraison, le client est bloqu");
			}
			else {
				var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
				param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
				param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
				param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
				param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
				param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
				param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
				param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
				param_retour += "&ComValide="+ ParamValeur("ComValide");
				param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

				var page = "chrome://opensi/content/facturation/user/affaires/bon_livraison.xul?"+ cookie();
				page += "&Affaire_Id="+ affaire_id +"&Bon_Id="+ bon_id +"&ParamRetour="+ urlEncode(param_retour);
	  		window.location = page;
			}
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function annulerBon() {
  try {
	
		if (window.confirm("Confirmez-vous l'annulation du bon de livraison ?")) {
	
			var qAnnuler = new QueryHttp("Facturation/Affaires/annulerBL.tmpl");
			qAnnuler.setParam('Bon_Id', bon_id);
			qAnnuler.setParam('Com_Id', com_id);
			qAnnuler.execute();
			
			showMessage("Le bon de livraison a t annul");
			
			retour_affaire();
		}

	} catch (e) {
    recup_erreur(e);
  }
}


function rechercherAdrLiv() {
  try {
  	
  	current_code_pays_liv = document.getElementById("Code_Pays_Liv").value;

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixAdresse.xul?"+ cookie() +"&Client_Id="+ urlEncode(client_id);
    window.openDialog(url,'','chrome,modal,centerscreen', reporterAdrLiv);

	} catch (e) {
  	recup_erreur(e);
  }
}


function reporterAdrLiv(nom, adr1, adr2, adr3, cp, ville, pays, code_pays, contact_fact, contact_liv) {
  try {
  	
  	var qGetAssujetti = new QueryHttp("Facturation/Affaires/getCommande.tmpl");
		qGetAssujetti.setParam("Com_Id", com_id);
		var result = qGetAssujetti.execute();
		var content = result.responseXML.documentElement;
	  var assujettiTVA=(content.getAttribute("Assujetti_TVA")=="1");
  	
  	if (current_code_pays_liv!=code_pays && !assujettiTVA) {
  		showWarning("L'adresse choisie doit tre dans le mme pays que le pays de livraison actuel !");
  	} else {	
			document.getElementById("Denomination_Liv").value = nom;
			document.getElementById("Adresse_1_Liv").value = adr1;		
			document.getElementById("Adresse_2_Liv").value = adr2;
			document.getElementById("Adresse_3_Liv").value = adr3;
			document.getElementById("Code_Postal_Liv").value = cp;
			document.getElementById("Ville_Liv").value = ville;
			document.getElementById("Pays_Liv").value = pays;
		  document.getElementById("Code_Pays_Liv").value = code_pays;
			
			if (!isEmpty(contact_liv)) {
		  	var qInterLiv = new QueryHttp("Facturation/Clients/getContact.tmpl");
		  	qInterLiv.setParam("Num_Inter", contact_liv);
		  	var result = qInterLiv.execute();
		  	var content = result.responseXML.documentElement;
		  	reporterInterLiv(content.getAttribute("Civilite"),content.getAttribute("Civ_Courte"),content.getAttribute("Nom"),content.getAttribute("Prenom"),content.getAttribute("Tel"),content.getAttribute("Fax"),content.getAttribute("Email"));
		  } else {		
				setModifie(true);
		  }
  	}

	} catch (e) {
  	recup_erreur(e);
  }
}


function rechercherInterlocuteurLiv() {
  try {

		var url = "chrome://opensi/content/facturation/user/commun/popup-choixInter.xul?"+ cookie() +"&Client_Id="+ urlEncode(client_id);
    window.openDialog(url,'','chrome,modal,centerscreen', reporterInterLiv);

	} catch (e) {
  	recup_erreur(e);
  }
}


function reporterInterLiv(civ, civ_courte, nom, prenom, tel, fax, email) {
  try {
		document.getElementById("Civ_Inter_Liv").value = civ;
		document.getElementById("Civ_Inter_Courte_Liv").value = civ_courte;
		document.getElementById("Nom_Inter_Liv").value = nom;		
		document.getElementById("Prenom_Inter_Liv").value = prenom;
		document.getElementById("Tel_Inter_Liv").value = tel;
		document.getElementById("Fax_Inter_Liv").value = fax;
		document.getElementById("Email_Inter_Liv").value = email;
		
		setModifie(true);
	} catch (e) {
  	recup_erreur(e);
  }
}


function colisage() {
  try {
		var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
		param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
		param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
		param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
		param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
		param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
		param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
		param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
		param_retour += "&ComValide="+ com_id;
		param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

    var page = "chrome://opensi/content/facturation/user/affaires/colisage.xul?"+ cookie() +"&Bon_Id="+ bon_id +"&Affaire_Id="+ ParamValeur("Affaire_Id") +"&ParamRetour="+ urlEncode(param_retour);
    window.location = page;

  } catch (e) {
    recup_erreur(e);
  }
}


function editionBP() {
  try {

		var tree = document.getElementById("bon_livraison");

		if (tree.view==null || tree.view.rowCount<=0) {
			showWarning("Le bon de livraison ne contient aucune ligne !");
		}
		else {

			var param_retour = "&Affaire_Id="+ ParamValeur("Affaire_Id");
			param_retour += "&Raison_Sociale="+ urlEncode(ParamValeur("Raison_Sociale"));
			param_retour += "&Adresse_Fact="+ urlEncode(ParamValeur("Adresse_Fact"));
			param_retour += "&CP_Fact="+ urlEncode(ParamValeur("CP_Fact"));
			param_retour += "&Ville_Fact="+ urlEncode(ParamValeur("Ville_Fact"));
			param_retour += "&Client_Id="+ urlEncode(ParamValeur("Client_Id"));
			param_retour += "&Nom_Affaire="+ urlEncode(ParamValeur("Nom_Affaire"));
			param_retour += "&Responsable="+ urlEncode(ParamValeur("Responsable"));
			param_retour += "&ComValide="+ com_id;
			param_retour += "&Num_Affaire="+ urlEncode(ParamValeur("Num_Affaire"));

    	var page = "chrome://opensi/content/facturation/user/affaires/bon_preparation.xul?"+ cookie() +"&Bon_Id="+ bon_id +"&Affaire_Id="+ ParamValeur("Affaire_Id") +"&ParamRetour="+ urlEncode(param_retour);
    	window.location = page;
		}

  } catch (e) {
    recup_erreur(e);
  }
}


function choisirMentions() {
  try {
  	
  	var ok = true;
  	
  	if (mode=="C") {
			ok = enregistrerBon();
		}

		if (ok) {
			var url = "chrome://opensi/content/facturation/user/commun/popup-choix_mentions.xul?"+ cookie() +"&Type_Doc=Bon_Livraison&Doc_Id="+ bon_id;
	    window.openDialog(url,'','chrome,modal,centerscreen',setModifie);
		}

	} catch (e) {
  	recup_erreur(e);
  }
}


function menuAffaires() {
  try {

    window.location = "chrome://opensi/content/facturation/user/affaires/menu_affaires.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_affaire() {
  try {

    window.location = "chrome://opensi/content/facturation/user/affaires/fiche_affaire.xul?"+ cookie() +"&Mode=M&Affaire_Id="+ affaire_id;

  } catch (e) {
    recup_erreur(e);
  }
}


function retour_menu_principal() {
  try {

    window.location = "chrome://opensi/content/facturation/user/menu_principal.xul?"+ cookie();

  } catch (e) {
    recup_erreur(e);
  }
}
