/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package org.opensi.facturation.actions.documents.modeles;


import java.util.Comparator;

/**
 * Classe permettant de comparer deux VentilTVA sur leur attribut tauxTVA
 * @author jm
 */
class ComparateurTva implements Comparator<VentilTVA> {
	
	/**
	 * Compare deux objets de type VentilTVA
	 * 
	 * @param ventilation		un Object VentilTVA
	 * @param autreVentilation	un second Object VentilTVA à comparer au premier
	 * @throws ClassCastException si un des deux Objects passés en paramètre n'est pas un VentilTVA
	 * @return 0 si les deux VentilTVA sont identiques par leur attribut tauxTVA, un entier positif
	 *           ou négatif sinon.
	 */
	public int compare(VentilTVA ventilation, VentilTVA autreVentilation) {
		return (int) (ventilation.tauxTVA - autreVentilation.tauxTVA);
	}

}
